Index: lib/QubitQuery.class.php
===================================================================
--- lib/QubitQuery.class.php	(revision 6919)
+++ lib/QubitQuery.class.php	(working copy)
@@ -28,6 +28,7 @@
 
     $statement = null,
     $objects = null,
+    $count = null,
 
     $offset = 0,
 
@@ -240,19 +241,22 @@
   {
     if (!isset($this->objects))
     {
+      $count = 0;
+
       if (isset($this->parent))
       {
         $count = $this->parent->getCount($leaf);
       }
-      else
+      else if (isset($this->count))
       {
-        $count = 0;
+        $count = $this->count;
+      }
+      else if (isset($this->criteria))
+      {
+        $countCriteria = clone $this->criteria;
+        $this->count = intval(BasePeer::doCount($countCriteria)->fetchColumn(0));
 
-        if (isset($this->criteria))
-        {
-          list ($statement, $sorted) = $this->getStatement($leaf);
-          $count = $statement->rowCount();
-        }
+        $count = $this->count;
       }
 
       if (isset($this->andSelf))
